{{
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// Simple Debug main to allow me to see if I can get SPI comms from MBED to Propeller
// using the Very simple and well documented libs from Kwabena W. Agyeman
// This was initially checked in as a direct version of his demo.
//
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
}}

CON

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

  _pinGroup = 2
  _startUpWait = 5
                                      
OBJ

  vga: "VGA64_TMPEngine.spin"
  spi: "Comms.spin"

VAR

  word XPos, YPos, XDir, YDir
  

PUB demo | r

  r := 0
  spi.initLocalSPI
  ifnot(vga.TMPEngineStart(_pinGroup, @XPos, @YPos))
    reboot

  waitcnt((clkfreq * _startUpWait) + cnt)
  vga.display2DBox(vga#Dark_Blue, 0, 0, 29, 39)
  repeat
    vga.displayString(string("Tile Map Driver Demo"), vga#black, vga#Dark_Green, 14, 10)
    r := spi.getVal
    printInt( r, 16, 16 )
    r := spi.getRtn
    printInt( r, 16, 20 )
    
    'waitcnt((clkfreq * 5) + cnt)

PUB printInt( i, x, y )
  repeat
    case ( i & $F )
      0: vga.displayCharacter( "0", vga#black, vga#white, y, x ) 
      1: vga.displayCharacter( "1", vga#black, vga#white, y, x ) 
      2: vga.displayCharacter( "2", vga#black, vga#white, y, x ) 
      3: vga.displayCharacter( "3", vga#black, vga#white, y, x ) 
      4: vga.displayCharacter( "4", vga#black, vga#white, y, x ) 
      5: vga.displayCharacter( "5", vga#black, vga#white, y, x ) 
      6: vga.displayCharacter( "6", vga#black, vga#white, y, x ) 
      7: vga.displayCharacter( "7", vga#black, vga#white, y, x ) 
      8: vga.displayCharacter( "8", vga#black, vga#white, y, x ) 
      9: vga.displayCharacter( "9", vga#black, vga#white, y, x ) 
      10: vga.displayCharacter( "A", vga#black, vga#white, y, x ) 
      11: vga.displayCharacter( "B", vga#black, vga#white, y, x ) 
      12: vga.displayCharacter( "C", vga#black, vga#white, y, x ) 
      13: vga.displayCharacter( "D", vga#black, vga#white, y, x ) 
      14: vga.displayCharacter( "E", vga#black, vga#white, y, x ) 
      15: vga.displayCharacter( "F", vga#black, vga#white, y, x )
    i >>= 4
    x -= 1     
  until i == 0
  
    
{{

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                  TERMS OF USE: MIT License
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy,
// modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in all copies or substantial portions of the
// Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
// WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
// COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
// ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
}}